const {
  api
} = require("../../utils/api")
const config = require("../../config/config")
// pages/user/index.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    user: null,
    info: null,
    inviteCode: '',
    badgeList:[]
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    const tmp = wx.getStorageSync('user')
    if (tmp) {
      this.setData({
        user: tmp
      })
    }
    const inviteCode = wx.getStorageSync('inviteCode')
    this.setData({
      inviteCode: inviteCode
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    this.fetchInfo()
  },
  fetchInfo() {
    api('/personal/personal', 'GET').then(res => {
      if (res.code === 200) {
        const tmps = res.data
        this.setData({
          info: tmps
        })
      }
    })

    api('/badge/my/list','POST',{current:0, pageSize:999},'json').then(res => {
      if (res.code === 200) {
        const tmps = res.data.list
        this.setData({badgeList:tmps})
      }
    })
  },

  onChooseAvatar(e) {
    const avatarUrl = e.detail.avatarUrl
    // 上传
    const _this = this
    wx.uploadFile({
      filePath: avatarUrl,
      name: 'file',
      header: {
        'Authorization': 'Bearer ' + wx.getStorageSync('token'),
      },
      url: config.baseUrl + '/oss/upload',
      success: res => {
        var data = JSON.parse(res.data)

        if (data.code === 200) {
          const tmps = _this.data.user
          tmps.avatar = data.data.file
          tmps.avatarId = data.data.file.id
          _this.setData({
            user: tmps
          })
          _this.update()
        }
      }
    })
  },

  update() {
    api('/user/update', 'POST', this.data.user, "json").then(res => {
      if (res.code === 200) {

      }
    })
  },

  goStore() {
    wx.navigateTo({
      url: '../store/index',
    })
  },

  goAbout() {
    wx.navigateTo({
      url: '../user/about',
    })
  },

  goPrivate() {
    wx.openPrivacyContract()
  },


  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {
    return {
      title: '发现一个宝藏养花神器',
      imageUrl: "https://res.catter.cn/pub/2025/12/08/20251208112039694.png",
      path: '/pages/index/index?inviteCode=' + this.data.inviteCode
    };
  },

  onShareTimeline() {
    return {
      title: '发现一个宝藏养花神器',
      imageUrl: "https://res.catter.cn/pub/2025/12/08/20251208112039694.png",
      path: '/pages/index/index?inviteCode=' + this.data.inviteCode
    };
  }
})